/*
 * 作成日: 2005/01/24
 */
package jp.co.kayo.io;


/**
 * TODO 説明を定義してください。
 *
 * @author MasafumiTerazono
 * @version $Id: GameStartRecord.java,v 1.1 2005/02/13 06:39:48 epepe Exp $
 */
public class GameStartRecord {
    /** TODO 説明を定義してください。 */
    private int m_selectmode;

    /** TODO 説明を定義してください。 */
    private int m_startspotcount;

    /** TODO 説明を定義してください。 */
    private long m_randomseed;

    /**
     * Creates a new GameStartRecord object.
     *
     * @param data TODO 説明を定義してください。
     * @param replay TODO 説明を定義してください。
     */
    public GameStartRecord(ReplayRecord data, ReplayBuffer replay) {
        int recordID = replay.get();

        if (recordID == 0x19) {
            replay.skip(2);

            int nr = replay.get();
            int flag;

            for (int i = 0; i < nr; i++) {
                byte playerid = replay.get();

                //player id (0x00 for computer players)
                //unknown (0xff in ladder, 0x64 in custom ???)
                replay.skip();

                //0x00 empty slot
                //0x01 closed slot
                //0x02 used slot
                int slotstatus = replay.get();

                //0x00 for human player
                //0x01 for computer player
                int computerplayerflag = replay.get();

                //team number:0 - 11
                //(team 12 == observer or referee)
                int teamnumber = replay.get();

                //color (0-11):
                //value+1 matches player colors in world editor:
                //(red, blue, cyan, purple, yellow, orange, green, pink, gray,
                // light blue, dark green, brown)
                int color = replay.get();

                //0x01=human 0x02=orc 0x04=nightelf 0x08=undead 0x20=random
                // 0x40=race selectable/fixed (see notes below)
                byte playerraceflags = replay.get();

                //0x00 for easy 0x01 for normal 0x02 for insane for non-AI
                // players this seems to be always 0x01
                int computerAIstrength = replay.get();

                int playerhandicapinpercent = replay.get();

                PlayerRecord player = (PlayerRecord) data.getPlayermap().get(new Integer(
                            playerid));

                if (player != null) {
                    player.setRace(playerraceflags&0x3F);
                    player.setColor(color);
                    player.setHandicap(playerhandicapinpercent);
                    player.setSlotstatus(slotstatus);
                    player.setComputerPlayerFlag(computerplayerflag);
                    player.setTeam(teamnumber);
                }
            }
        }

        m_randomseed = replay.getInt();
        m_selectmode = replay.get();
        m_startspotcount = replay.get();
    }

    /**
     * TODO 説明を定義してください。
     *
     * @return TODO 説明を定義してください。
     */
    public long getRandomseed() {
        return this.m_randomseed;
    }

    /**
     * TODO 説明を定義してください。
     *
     * @return TODO 説明を定義してください。
     */
    public int getSelectmode() {
        return this.m_selectmode;
    }

    /**
     * TODO 説明を定義してください。
     *
     * @return TODO 説明を定義してください。
     */
    public int getStartspotcount() {
        return this.m_startspotcount;
    }
}